//-----------------------------------------------------------------------------
// Tools.pas
//
// Last updated at: 14/08/1998
//
// some nice and helpfull routines, check the Tools.Txt
//
// Code by: Liran Shahar
//          Israel
//          simpletech@ibm.net
//-----------------------------------------------------------------------------
unit Tools;

interface

uses
  Controls,StdCtrls;

procedure EnableControls(const Ctrls : array of TControl;Enable : boolean);
procedure ClearControls(const Ctrls : array of TControl);

implementation

type
  PCtrlsArray = ^TCtrlsArray;
  TCtrlsArray = array [0..$FFFF] of TControl;

//-----------------------------------------------------------------------------
procedure EnableControls(const Ctrls : array of TControl;Enable : boolean);
var
  Loop,Index,Count : integer;
  CtrlsPtr         : PCtrlsArray;
begin
  for Loop:=low(Ctrls) to high(Ctrls) do begin
    Ctrls[Loop].Enabled:=Enable;
    if Ctrls[Loop] is TWinControl then with Ctrls[Loop] as TWinControl do begin
      Count:=ControlCount;
      if Count>0 then begin
        getmem(CtrlsPtr,Count*sizeof(TControl));
        try
          for Index:=0 to Count-1 do CtrlsPtr^[Index]:=Controls[Index];
          EnableControls(Slice(CtrlsPtr^,Count),Enable);
        finally
          freemem(CtrlsPtr,Count*sizeof(TControl));
          CtrlsPtr:=nil;
        end; { try/finally }
      end; // if Count
    end; // if Ctrls
  end; // for Index
end; // EnableControls

//-----------------------------------------------------------------------------
procedure ClearControls(const Ctrls : array of TControl);
var
  Loop,Index,Count : integer;
  CtrlsPtr         : PCtrlsArray;
begin
  for Loop:=low(Ctrls) to high(Ctrls) do begin
    if Ctrls[Loop] is TCustomEdit then
      TCustomEdit(Ctrls[Loop]).Text:=''
    else if Ctrls[Loop] is TCustomComboBox then
      TCustomComboBox(Ctrls[Loop]).ItemIndex:=-1
    else if Ctrls[Loop] is TCustomListBox then
      TCustomListBox(Ctrls[Loop]).ItemIndex:=-1
    else if Ctrls[Loop] is TCustomCheckBox then
      TCheckBox(Ctrls[Loop]).Checked:=false;
    if Ctrls[Loop] is TWinControl then with Ctrls[Loop] as TWinControl do begin
      Count:=ControlCount;
      if Count>0 then begin
        getmem(CtrlsPtr,Count*sizeof(TControl));
        try
          for Index:=0 to Count-1 do CtrlsPtr^[Index]:=Controls[Index];
          ClearControls(Slice(CtrlsPtr^,Count));
        finally
          freemem(CtrlsPtr,Count*sizeof(TControl));
          CtrlsPtr:=nil;
        end; { try/finally }
      end; // if Count
    end; // if Ctrls
  end; // for Index
end; // ClearControls

end.
